package edu.berkeley.cs.cs162;

/**
   A Game represents a single game of Go. There may be multiple games running at
   once, each with two players and any number of observers. The Game must keep
   track of the board state and check whether or not moves made by players are
   valid. If a player's move is not valid, the game should end immediately and
   the player who made the invalid move loses.

   The Game is responsible for informing all players and observers of all game
   events and deciding when a game is over. All players and observers should be
   kept track of by name. Games may not have direct access to Observer or Player
   objects.
 */
public class Game implements Runnable {

    public Game(GameServer server, String gameName, String blackPlayer, String whitePlayer, Board initialBoard, int moveTimeoutInMs) {
	// TODO: implement me
    }

    /**
       Add an observer by the given name to watch this game.
     */
    public void addObserver(String observerName) {
	// TODO: implement me
    }

    /**
       Remove an observer by the given name from watching this game.
     */
    public void removeObserver(String observerName) {
	// TODO: implement me
    }

    /**
       Record a move made made by the given player.
     */
    public void makeMove(String playerName, Location loc) {
	// TODO: implement me
    }

    /**
       Record that the given player has chosen to pass its turn.
     */
    public void makePassMove(String playerName) {
	// TODO: implement me
    }

    /**
       @return The name of this game.
     */
    public String getName() {
	// TODO: implement me
	return null;
    }

    /**
       @return The current board state.
     */
    public Board getBoard() {
	// TODO: implement me
	return null;
    }

    /**
       Wait until the game has finished.
     */
    public void waitForGameOver() {
	// TODO: implement me
    }

    public void run() {
	// TODO: implement me
    }
    
}
